#!/bin/bash

# Define here the installation path for your platform
function setup
{
  case "$HOSTNAME" in
    Mizar)
      install_path="$PWD/install"
      debug="OFF"
      optimize="ON"
      nitpicking="ON"
      verbose="ON"
      ;;
    *)
      install_path="$PWD/install"
      debug="OFF"
      optimize="ON"
      nitpicking="OFF"
      verbose="OFF"
      ;;
  esac
}

function build
{
  mkdir -p build                                  || exit 1
  cd build                                        || exit 1
  cmake -DCMAKE_INSTALL_PREFIX:PATH=$install_path \
        -Ddebug=$debug                            \
        -Doptimize=$optimize                      \
        -Dnitpicking=$nitpicking                  \
        -Dverbose=$verbose                        \
        ..                                        || exit 1
  make -j 8                                       || exit 1
  make install                                    || exit 1
  cd ..                                           || exit 1
}

function clean
{
  cd build   || exit 1
  make clean || exit 1
  cd ..      || exit 1
}

for arg in "$@"
do
  case "$arg" in
    -c|clean)
      clean
      ;;
    -b|build)
      setup &&
      build
      ;;
  esac
done
