/*\
* lenactions
* A simple image editing library
* Copyrigth 2013 - Hadrien Croubois
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
\*/

#ifndef CONVOLUTION_HH
#define CONVOLUTION_HH

namespace lenactions {

	template <typename T, size_t H, size_t V, class Enable = typename std::enable_if<H%2 && V%2, void>::type>
	class Kernel : public std::array<std::array<T, V>, H>
	{
			using container = std::array<std::array<T, V>, H>;
		public:
			Kernel() = default;
			Kernel(const Kernel&) = default;
			Kernel(Kernel&&     ) = default;

			Kernel(const container& data) : std::array<std::array<T, V>, H>(data) {}
	};
}


#endif
